"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrossmintPayButton = void 0;
const react_1 = __importStar(require("react"));
const useCrossmintStatus_1 = __importStar(require("./hooks/useCrossmintStatus"));
const useCrossmintModal_1 = __importDefault(require("./hooks/useCrossmintModal"));
const styles_1 = require("./styles");
const utils_1 = require("./utils");
const types_1 = require("./types");
const defaultMintConfig = {
    type: types_1.mintingContractTypes.CANDY_MACHINE,
};
const CrossmintPayButton = (_a) => {
    var { className, disabled, onClick, style, tabIndex, theme = "dark", collectionTitle, collectionDescription, collectionPhoto, mintTo, emailTo, listingId, clientId, development = false, auctionId, hideMintOnInactiveClient = false, showOverlay = true, mintConfig = defaultMintConfig } = _a, props = __rest(_a, ["className", "disabled", "onClick", "style", "tabIndex", "theme", "collectionTitle", "collectionDescription", "collectionPhoto", "mintTo", "emailTo", "listingId", "clientId", "development", "auctionId", "hideMintOnInactiveClient", "showOverlay", "mintConfig"]);
    const status = (0, useCrossmintStatus_1.default)({ clientId, development });
    const { connecting, connect } = (0, useCrossmintModal_1.default)({
        clientId,
        development,
        showOverlay,
    });
    if (collectionTitle === "<TITLE_FOR_YOUR_COLLECTION>") {
        console.warn("No collection title specified. Please add a collection title to your <CrossmintPayButton />");
        collectionTitle = "";
    }
    if (collectionDescription === "<DESCRIPTION_OF_YOUR_COLLECTION>") {
        console.warn("No collection description specified. Please add a collection description to your <CrossmintPayButton />");
        collectionDescription = "";
    }
    if (collectionPhoto === "<OPT_URL_TO_PHOTO_COVER>") {
        console.warn("No collection photo specified. Please add a collection photo to your <CrossmintPayButton />");
        collectionPhoto = "";
    }
    const handleClick = (0, react_1.useCallback)((event) => {
        if (onClick)
            onClick(event);
        if (!event.defaultPrevented) {
            connect(mintConfig, collectionTitle, collectionDescription, collectionPhoto, mintTo, emailTo, listingId);
        }
    }, [onClick]);
    const classes = (0, styles_1.useStyles)((0, styles_1.formatProps)(theme));
    const content = (0, react_1.useMemo)(() => {
        if (connecting)
            return react_1.default.createElement("p", { className: classes.crossmintParagraph }, "Connecting ...");
        return react_1.default.createElement("p", { className: classes.crossmintParagraph }, "Buy with credit card");
    }, [connecting]);
    if (hideMintOnInactiveClient && status !== useCrossmintStatus_1.OnboardingRequestStatusResponse.ACCEPTED) {
        return null;
    }
    return (react_1.default.createElement(react_1.default.Fragment, null, utils_1.isClientSide && (react_1.default.createElement("button", Object.assign({ className: `${classes.crossmintButton} ${className || ""}`, disabled: disabled, onClick: handleClick, style: Object.assign({}, style), tabIndex: tabIndex }, props),
        react_1.default.createElement("img", { className: classes.crossmintImg, src: "https://www.crossmint.io/assets/crossmint/logo.png", alt: "Crossmint logo" }),
        content))));
};
exports.CrossmintPayButton = CrossmintPayButton;
//# sourceMappingURL=CrossmintPayButton.js.map